#!/usr/bin/perl 
##
##  Sam's Exciting XMMS Remote Script  (SEXMMS)
##     -- or -- "In search of another dumb acronym"
##
## Here's a quick little XMMS control script, similar to BX+XMMS,
## for x-chat.  It requires the Xmms modules from CPAN, as well as
## MP3::Info.  The upshot of this is that it requires *no* patching of
## either x-chat, or xmms.
##
##
##


# shouldn't need to change this, but just in case..
$workpl = "~/.xchat/sexmms/xmmswork.pl";

# would you like control buttons?
$addbuttons = 1;

IRC::register("SEXMMS control script", ".5", "", "");
IRC::print "\002Loading SEXMMS Remote Script...\n";
IRC::add_command_handler("xmms-show", "show_song_info");
IRC::add_command_handler("xmms-next", "play_next_song");
IRC::add_command_handler("xmms-prev", "play_prev_song");
IRC::add_command_handler("xmms-play", "play_button");
IRC::add_command_handler("xmms-pause", "pause_button");
IRC::add_command_handler("xmms-stop", "stop_button");
IRC::add_command_handler("xmms-shuffle", "shuffle_button");


# I commented out the buttons I don't use much.  
# feel free to re-add them, of course.
if (defined $addbuttons) {
  IRC::command("/addbutton Play /xmms-play");
#  IRC::command("/addbutton Pause /xmms-pause");
#  IRC::command("/addbutton Shuffle /xmms-shuffle");
  IRC::command("/addbutton Stop /xmms-stop");
  IRC::command("/addbutton Previous /xmms-prev");
  IRC::command("/addbutton Next /xmms-next");
#  IRC::command("/addbutton Show /xmms-show");
}

sub get_song_info {
  my($raw, @SONG);
  $raw = `$workpl show`;
  (@SONG) = split(/\n/, $raw);
  return @SONG;
}

sub nope {
  IRC::print "\002--- XMMS is not running!\n";
}

sub show_song_info {
  my($raw, @SONG);
  @SONG = get_song_info;
  if (defined $SONG[0]) {
	 IRC::command("/me is listening to $SONG[0] by $SONG[1].");
  } else { nope; }
  return 1;
}

sub play_next_song {
  `$workpl next`;
  @SONG = get_song_info;
  if (defined $SONG[0]) {
	 IRC::print "\002--- Now playing $SONG[0] by $SONG[1].\n";
  } else { nope; }
  return 1;
}

sub play_prev_song {
  `$workpl prev`;
  @SONG = get_song_info;
  if (defined $SONG[0]) {
	 IRC::print "\002--- Now playing $SONG[0] by $SONG[1].\n";
  } else { nope; }
  return 1;
}
  
sub play_button {
  `$workpl play @_`;
  @SONG = get_song_info;
  if (defined $SONG[0]) {
	 IRC::print "\002--- Now playing $SONG[0] by $SONG[1].\n";
  } else { nope; }
  return 1;
}

sub stop_button {
  `$workpl stop`;
  IRC::print "\002--- XMMS Stopped.\n";
  return 1;
}

sub shuffle_button {
  `$workpl shuffle`;
  IRC::print "\002--- Shuffle Toggled.  No way to check to what.  Sucks, doesn't it?\n";
  return 1;
}

sub pause_button {
  `$workpl stop`;
  IRC::print "\002--- XMMS Paused.\n";
  return 1;
}

